# Do not modify this file!  It was generated by ‘nixos-generate-config’
# and may be overwritten by future invocations.  Please make changes
# to /etc/nixos/configuration.nix instead.
{ config, lib, pkgs, inputs, modulesPath, ... }:

{
  imports = [
    (modulesPath + "/installer/scan/not-detected.nix")
#    inputs.nixos-hardware.nixosModules.microsoft-surface
  ];

  # Kernel Modules
  boot = {
    initrd.availableKernelModules = [ "xhci_pci" "nvme" "usbhid" "usb_storage" "sd_mod" ];
    initrd.kernelModules = [ ];
    kernelPackages = pkgs.linuxPackages_zen;
    extraModulePackages = with config.boot.kernelPackages; [ v4l2loopback ];
    kernelModules = [ "kvm-intel" "v4l2loopback" ];
    loader = {
      systemd-boot = {
        enable = true;
        configurationLimit = 10;
      };
      efi.canTouchEfiVariables = true;
    };
  };

  # Modules
  modules.hardware = {
    audio = {
      enable = true;
      enableExtraCompat = true;
    };
    graphics.enable = true;
    fs = {
      enable = true;
      ssd.enable = true;
    };
  };

  # HiDPI
  hardware.video.hidpi.enable = true;

  # CPU
  nix.maxJobs = lib.mkDefault 4;
  hardware.cpu.intel.updateMicrocode = true;

  # Power Management
  powerManagement = {
    powertop.enable = true;
    cpuFreqGovernor = lib.mkDefault "powersave";
  };

  environment.systemPackages = with pkgs; [
    brightnessctl
  ];

  # Filesystems
  fileSystems = {
    "/" = {
      device = "/dev/disk/by-uuid/e1416adb-648e-4b34-b665-8305b7a765f8";
      fsType = "f2fs";
      options = [ "defaults" "noatime" "noadirtime" ];
    };

    "/boot" = {
      device = "/dev/disk/by-uuid/EB60-12E5";
      fsType = "vfat";
    };

    "/home/aether/Downloads" = {
      device = "none";
      fsType = "tmpfs";
    };

    "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56" = {
      device = "/dev/disk/by-uuid/bf2d91f1-a6b3-4629-8755-76301b3f6f56";
#      fsType = "ext4";
      options = [ "defaults" "noatime" "nodiratime" "user" "nofail" ];
    };

/*
    "/home/aether/Videos" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/home delta delta/Videos";
      options = [ "bind" ];
    };

    "/home/aether/Pictures" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/Pictures";
      options = [ "bind" ];
    };

    "/home/aether/Documents" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/Documents";
      options = [ "bind" ];
    };
*/
    "/home/aether/Music" = {
      device = "/run/media/aether/bf2d91f1-a6b3-4629-8755-76301b3f6f56/home delta/home delta delta/Music";
      options = [ "bind" ];
    };
  };

  swapDevices = [{ device = "/dev/disk/by-uuid/537cffdc-a67d-4b25-a649-32455cec4661"; }];
}
